/**************************************************************
    Project by Beycan Kahraman             on   26.11.2005
    
                      ODEV - 3             SORU - 5
**************************************************************/
/*
#include <iostream.h>      
#include <winbgim.cpp>
#include <math.h>

using namespace std;

#define GENISLIK 	800
#define YUKSEKLIK 	600
#define RENK 		15
#define RENK_IC		1
#define RENK_DIS	9
#define DETAY		50
#define ODAK		1000
#define PERDE		0
#define PI			3.1415
#define BIRKOK 		0.70710678

#define xMIN		-1.0
#define xMAX		2.0

int xBuyut = 200, yBuyut = 150;
int xKaydir = 200, yKaydir = 300;
int alfa = 0, beta = 0;

int Tip = 0;
int tmpClickX, tmpClickY;
int tmpX, tmpY;
bool click = false;
bool boya  = false;
bool cizik  = true;
bool egik  = false;

void click_handler(int a, int b){
	if(b < 20 && b > 10){
		if(a < 90 && a > 80)
			cizik = !cizik;
		else if(a < 76 && a > 66)
			egik = !egik;
		else if(a < 62 && a > 52)
			boya = !boya;
		else if(a < 48 && a > 38)
			Tip = 2;
		else if(a < 34 && a > 24)
			Tip = 1;
		else if(a < 20 && a > 10)
			Tip = 0;
		return;
	}
	click = true;
	tmpClickX = a;
	tmpClickY = b;
	if(Tip == 0){
		tmpX = xKaydir;
		tmpY = yKaydir;
	}else if(Tip == 1){
		tmpX = xBuyut;
		tmpY = yBuyut;
	}else if(Tip == 2){
		tmpX = alfa;
		tmpY = beta;
	}
}
void move_handler(int a, int b){
	if(!click)
		return;
	if(Tip == 0){
		xKaydir = (a-tmpClickX) + tmpX;
		yKaydir = (tmpClickY-b) + tmpY;
	}else if(Tip == 1){
		xBuyut 	= (a-tmpClickX) + tmpX;
		yBuyut 	= (tmpClickY-b) + tmpY;
	}else{
		alfa 	= ((tmpClickX-a) + tmpX)%360;
		beta 	= ((tmpClickY-b) + tmpY)%360;
	}
}
void up_handler(int a, int b){
	click = false;
}
void dogru(int x1, int y1, int x2, int y2){
	line(x1, YUKSEKLIK-y1, x2, YUKSEKLIK-y2);
}
void SecmeMenusu(){
	setcolor(2);
	rectangle(10,10,20,20);
	setcolor(4);
	rectangle(24,10,34,20);
	setcolor(1);
	rectangle(38,10,48,20);
	setcolor(5);
	rectangle(52,10,62,20);
	setcolor(7);
	rectangle(66,10,76,20);
	setcolor(6);
	rectangle(80,10,90,20);
	setcolor(15);
	rectangle(12 + 14*Tip,12,18 + 14*Tip,18);
	if(boya)
		rectangle(54,12,60,18);
	if(egik)
		rectangle(68,12,74,18);
	if(cizik)
		rectangle(82,12,88,18);
}
void Renk(int n){
	setcolor(n);
    setfillstyle(1, n);
}

float f(float x){
	return x*sin(x);
}

//	ANA PROGRAMA BASLIYORUZ

int main(){
    int i, j, k;
	int a = 0;
	float nx[2], ny[2], nz[2], x, y, z, tcol;
	float Nokta[DETAY][DETAY][3], n[DETAY][DETAY][3], nokta[DETAY][DETAY][3];
	int tmpNokta[8];

	initwindow( GENISLIK, YUKSEKLIK );
	registermousehandler( WM_LBUTTONDOWN, click_handler );
	registermousehandler( WM_MOUSEMOVE, move_handler );
	registermousehandler( WM_LBUTTONUP, up_handler );

	while(!kbhit()){
		a = (a+1)%2;
		setactivepage(a%2);
		clearviewport();
		
		for(j=0; j<DETAY; j++)
		for(i=0; i<DETAY; i++){
			Nokta[j][i][0] = xBuyut*(xMIN - (xMIN - xMAX)*i/(DETAY-1));
			Nokta[j][i][1] = yBuyut*f(xMIN - (xMIN - xMAX)*i/(DETAY-1))*cos(j*2*PI/DETAY);
			Nokta[j][i][2] = yBuyut*f(xMIN - (xMIN - xMAX)*i/(DETAY-1))*sin(j*2*PI/DETAY);
			
			n[j][i][0] = Nokta[j][i][0]*cos(alfa*PI/180) - sin(alfa*PI/180)*Nokta[j][i][2];
			n[j][i][1] = Nokta[j][i][1]*cos(alfa*PI/180) + (1-cos(alfa*PI/180))*Nokta[j][i][1];
			n[j][i][2] = Nokta[j][i][2]*cos(alfa*PI/180) + sin(alfa*PI/180)*Nokta[j][i][0];	
			
			nokta[j][i][0] = n[j][i][0]*cos(beta*PI/180) + (1-cos(beta*PI/180))*n[j][i][0];
			nokta[j][i][1] = n[j][i][1]*cos(beta*PI/180) + sin(beta*PI/180)*n[j][i][2];
			nokta[j][i][2] = n[j][i][2]*cos(beta*PI/180) - sin(beta*PI/180)*n[j][i][1];
			
			if(egik){
				nokta[j][i][0] = nokta[j][i][0]*(ODAK - PERDE)/(ODAK - nokta[j][i][2]);
				nokta[j][i][1] = nokta[j][i][1]*(ODAK - PERDE)/(ODAK - nokta[j][i][2]);
			}
		}
		
		SecmeMenusu();
		setcolor(8);
		dogru(0,yKaydir,GENISLIK,yKaydir);
		dogru(xKaydir,0,xKaydir,YUKSEKLIK);
		if(boya){
			Renk(RENK_IC);
			for(j=0; j<DETAY; j++)
				for(i=0; i<DETAY-1; i++){
					tmpNokta[0] = (int)(nokta[j][i][0] + xKaydir);
					tmpNokta[1] = (int)(YUKSEKLIK - (nokta[j][i][1] + yKaydir));
					tmpNokta[2] = (int)(nokta[j][i+1][0] + xKaydir);
					tmpNokta[3] = (int)(YUKSEKLIK - (nokta[j][i+1][1] + yKaydir));
					tmpNokta[4] = (int)(nokta[(j+1)%DETAY][i+1][0] + xKaydir);
					tmpNokta[5] = (int)(YUKSEKLIK - (nokta[(j+1)%DETAY][i+1][1] + yKaydir));
					tmpNokta[6] = (int)(nokta[(j+1)%DETAY][i][0] + xKaydir);
					tmpNokta[7] = (int)(YUKSEKLIK - (nokta[(j+1)%DETAY][i][1] + yKaydir));
					if((nokta[(j+1)%DETAY][i][0]-nokta[j][i][0])*(nokta[j][i][1] - nokta[j][i+1][1]) > (nokta[(j+1)%DETAY][i][1]-nokta[j][i][1])*(nokta[j][i][0] - nokta[j][i+1][0])){
						nx[0] = nokta[j][i+1][0] - nokta[j][i][0];
						ny[0] = nokta[j][i+1][1] - nokta[j][i][1];
						nz[0] = nokta[j][i+1][2] - nokta[j][i][2];
						nx[1] = nokta[j][i][0] - nokta[(j+1)%DETAY][i][0];
						ny[1] = nokta[j][i][1] - nokta[(j+1)%DETAY][i][1];
						nz[1] = nokta[j][i][2] - nokta[(j+1)%DETAY][i][2];
						x = ny[0]*nz[1] - ny[1]*nz[0];
						y = -nx[0]*nz[1] + nx[1]*nz[0];
						z = nx[0]*ny[1] - nx[1]*ny[0];
						tcol = z/sqrt(x*x + y*y + z*z);
						if(tcol <= 0){
							Renk(COLOR(-200*tcol,-200*tcol,200));
							fillpoly(4, tmpNokta);
						}
					}
				}
		}
		if(boya){
			Renk(RENK_DIS);
			for(j=0; j<DETAY; j++)
				for(i=0; i<DETAY-1; i++){
					tmpNokta[0] = (int)(nokta[j][i][0] + xKaydir);
					tmpNokta[1] = (int)(YUKSEKLIK - (nokta[j][i][1] + yKaydir));
					tmpNokta[2] = (int)(nokta[j][i+1][0] + xKaydir);
					tmpNokta[3] = (int)(YUKSEKLIK - (nokta[j][i+1][1] + yKaydir));
					tmpNokta[4] = (int)(nokta[(j+1)%DETAY][i+1][0] + xKaydir);
					tmpNokta[5] = (int)(YUKSEKLIK - (nokta[(j+1)%DETAY][i+1][1] + yKaydir));
					tmpNokta[6] = (int)(nokta[(j+1)%DETAY][i][0] + xKaydir);
					tmpNokta[7] = (int)(YUKSEKLIK - (nokta[(j+1)%DETAY][i][1] + yKaydir));
					if((nokta[(j+1)%DETAY][i][0]-nokta[j][i][0])*(nokta[j][i][1] - nokta[j][i+1][1]) < (nokta[(j+1)%DETAY][i][1]-nokta[j][i][1])*(nokta[j][i][0] - nokta[j][i+1][0])){
						nx[0] = nokta[j][i+1][0] - nokta[j][i][0];
						ny[0] = nokta[j][i+1][1] - nokta[j][i][1];
						nz[0] = nokta[j][i+1][2] - nokta[j][i][2];
						nx[1] = nokta[j][i][0] - nokta[(j+1)%DETAY][i][0];
						ny[1] = nokta[j][i][1] - nokta[(j+1)%DETAY][i][1];
						nz[1] = nokta[j][i][2] - nokta[(j+1)%DETAY][i][2];
						x = ny[0]*nz[1] - ny[1]*nz[0];
						y = -nx[0]*nz[1] + nx[1]*nz[0];
						z = nx[0]*ny[1] - nx[1]*ny[0];
						tcol = z/sqrt(x*x + y*y + z*z);
						if(tcol >= 0){
							Renk(COLOR(255*tcol,255*tcol,255));
							fillpoly(4, tmpNokta);
						}
					}
				}
		}
		if(cizik){
			setcolor(RENK);
			for(j=0; j<DETAY; j++){
				for(i=0; i<DETAY-1; i++){
					dogru(nokta[j][i][0] + xKaydir,nokta[j][i][1] + yKaydir,nokta[j][i+1][0] + xKaydir,nokta[j][i+1][1] + yKaydir);
					dogru(nokta[j][i][0] + xKaydir,nokta[j][i][1] + yKaydir,nokta[(j+1)%DETAY][i][0] + xKaydir,nokta[(j+1)%DETAY][i][1] + yKaydir);
				}
				dogru(nokta[j][DETAY-1][0] + xKaydir,nokta[j][DETAY-1][1] + yKaydir,nokta[(j+1)%DETAY][DETAY-1][0] + xKaydir,nokta[(j+1)%DETAY][DETAY-1][1] + yKaydir);
			}
		}
		setvisualpage(a%2);
	}
	return 1;
}
*/
