/**************************************************************
    Project by Beycan Kahraman             on   26.11.2005
    
                      ODEV - 3             SORU - 6
**************************************************************/

#include <iostream.h>      
#include <winbgim.cpp>
#include <math.h>

using namespace std;

#define GENISLIK 	800
#define YUKSEKLIK 	600
#define DETAY 		20
#define PI 			3.14159
#define RENK_CIZ 	15
#define ODAK 		1000
#define PERDE 		0

int xBuyut = 100, yBuyut = 100;
int xKaydir = 200, yKaydir = 200;
int alfa = 0, beta = 0;

int Tip = 0;
int tmpClickX, tmpClickY;
int tmpX, tmpY;
bool click = false;
bool boya  = false;
bool cizik  = true;
bool egik  = false;

void click_handler(int a, int b){
	if(b < 20 && b > 10){
		if(a < 90 && a > 80)
			cizik = !cizik;
		else if(a < 76 && a > 66)
			egik = !egik;
		else if(a < 62 && a > 52)
			boya = !boya;
		else if(a < 48 && a > 38)
			Tip = 2;
		else if(a < 34 && a > 24)
			Tip = 1;
		else if(a < 20 && a > 10)
			Tip = 0;
		return;
	}
	click = true;
	tmpClickX = a;
	tmpClickY = b;
	if(Tip == 0){
		tmpX = xKaydir;
		tmpY = yKaydir;
	}else if(Tip == 1){
		tmpX = xBuyut;
		tmpY = yBuyut;
	}else if(Tip == 2){
		tmpX = alfa;
		tmpY = beta;
	}
}
void move_handler(int a, int b){
	if(!click)
		return;
	if(Tip == 0){
		xKaydir = (a-tmpClickX) + tmpX;
		yKaydir = (tmpClickY-b) + tmpY;
	}else if(Tip == 1){
		xBuyut 	= (a-tmpClickX) + tmpX;
		yBuyut 	= (tmpClickY-b) + tmpY;
	}else{
		alfa 	= ((tmpClickX-a) + tmpX)%360;
		beta 	= ((tmpClickY-b) + tmpY)%360;
	}
}
void up_handler(int a, int b){
	click = false;
}
void dogru(int x1, int y1, int x2, int y2){
	//if(x1 < 0 || x2 < 0 || y1 < 0 || y2 < 0)
	//	return;
	//if(x1 > GENISLIK || x2 > GENISLIK || y1 > YUKSEKLIK || y2 > YUKSEKLIK)
	//	return;
	line(x1, YUKSEKLIK -y1, x2, YUKSEKLIK-y2);
}
float Bez(float *X, float t){
    return (1-t)*(1-t)*(1-t)*X[0] + 3*t*(1-t)*(1-t)*X[1] + 3*t*t*(1-t)*X[2] + t*t*t*X[3];
}
float f(float z){
    return -z*z/8 + 2;
}
void SecmeMenusu(){
	setcolor(2);
	rectangle(10,10,20,20);
	setcolor(4);
	rectangle(24,10,34,20);
	setcolor(1);
	rectangle(38,10,48,20);
	setcolor(5);
	rectangle(52,10,62,20);
	setcolor(7);
	rectangle(66,10,76,20);
	setcolor(6);
	rectangle(80,10,90,20);
	setcolor(15);
	rectangle(12 + 14*Tip,12,18 + 14*Tip,18);
	if(boya)
		rectangle(54,12,60,18);
	if(egik)
		rectangle(68,12,74,18);
	if(cizik)
		rectangle(82,12,88,18);
}
void Renk(int n){
	setcolor(n);
    setfillstyle(1, n);
}

//	ANA PROGRAMA BASLIYORUZ

int main(){
    int i, j, k;
	int a = 0, tmp[8];
	float t = 0;
	float Orj[DETAY][DETAY][3] = {0.0};
	float Yeni[DETAY][DETAY][3] = {0.0};
	float Yedek[DETAY][DETAY][3] = {0.0};
	float Ciz[DETAY][DETAY][3] = {0.0};
	float BezierX[4] = {0.0}, BezierY[4] = {0.0};
	float nx[2] = {0.0}, ny[2] = {0.0}, nz[2] = {0.0}, x, y, z, tcol = 0.0;
	int Sira[DETAY][DETAY][3];
	
	BezierX[0] = 0;     	BezierY[0] = 2;
    BezierX[1] = 2;			BezierY[1] = 1;
    BezierX[2] = 4;     	BezierY[2] = 2;
    BezierX[3] = 4;     	BezierY[3] = 4;
    
    for(i = 0; i<DETAY; i++){
		for(j = 0; j<DETAY; j++){
			t = j/(float)DETAY;
			Orj[i][j][0] = Bez(BezierX, t);
			Orj[i][j][2] = (i/(float)(DETAY-1))*4;
			Orj[i][j][1] = Bez(BezierY, t) + f(Orj[i][j][2]) - 2;
		}
	}

	initwindow( GENISLIK, YUKSEKLIK );
	registermousehandler( WM_LBUTTONDOWN, click_handler );
	registermousehandler( WM_MOUSEMOVE, move_handler );
	registermousehandler( WM_LBUTTONUP, up_handler );

	while(!kbhit()){
		a = (a+1)%2;
		setactivepage(a%2);
		clearviewport();
		
		for(i = 0; i<DETAY; i++)
			for(j = 0; j<DETAY; j++){
				Yeni[i][j][0] = Orj[i][j][0]*xBuyut;
				Yeni[i][j][1] = Orj[i][j][1]*yBuyut;
				Yeni[i][j][2] = Orj[i][j][2]*yBuyut;
			
				Yedek[j][i][0] = Yeni[j][i][0]*cos(alfa*PI/180) - sin(alfa*PI/180)*Yeni[j][i][2];
				Yedek[j][i][1] = Yeni[j][i][1]*cos(alfa*PI/180) + (1-cos(alfa*PI/180))*Yeni[j][i][1];
				Yedek[j][i][2] = Yeni[j][i][2]*cos(alfa*PI/180) + sin(alfa*PI/180)*Yeni[j][i][0];	
				
				Ciz[j][i][0] = Yedek[j][i][0]*cos(beta*PI/180) + (1-cos(beta*PI/180))*Yedek[j][i][0];
				Ciz[j][i][1] = Yedek[j][i][1]*cos(beta*PI/180) + sin(beta*PI/180)*Yedek[j][i][2];
				Ciz[j][i][2] = Yedek[j][i][2]*cos(beta*PI/180) - sin(beta*PI/180)*Yedek[j][i][1];
				
				if(egik){
					Ciz[j][i][0] = Ciz[j][i][0]*(ODAK - PERDE)/(ODAK - Ciz[j][i][2]);
					Ciz[j][i][1] = Ciz[j][i][1]*(ODAK - PERDE)/(ODAK - Ciz[j][i][2]);
				}
				
				Ciz[j][i][0] += xKaydir;
				Ciz[j][i][1] += yKaydir;
				
				Sira[i][j][0] = i;
				Sira[i][j][1] = j;
				Sira[i][j][2] = Ciz[j][i][2];
			}
		
		SecmeMenusu();
		
		Renk(2);
		dogru(0,yKaydir,GENISLIK,yKaydir);
		dogru(xKaydir,0,xKaydir,YUKSEKLIK);
		
		if(boya)
			for(i = 0; i<DETAY-1; i++)
				for(j = 0; j<DETAY-1; j++){
					tmp[0] = (int)(Ciz[i][j][0]);
					tmp[1] = (int)(YUKSEKLIK - Ciz[i][j][1]);
					tmp[2] = (int)(Ciz[i+1][j][0]);
					tmp[3] = (int)(YUKSEKLIK - Ciz[i+1][j][1]);
					tmp[4] = (int)(Ciz[i+1][j+1][0]);
					tmp[5] = (int)(YUKSEKLIK - Ciz[i+1][j+1][1]);
					tmp[6] = (int)(Ciz[i][j+1][0]);
					tmp[7] = (int)(YUKSEKLIK - Ciz[i][j+1][1]);
						
					nx[0] = Ciz[i][j+1][0] - Ciz[i][j][0];
					ny[0] = Ciz[i][j+1][1] - Ciz[i][j][1];
					nz[0] = Ciz[i][j+1][2] - Ciz[i][j][2];
					nx[1] = Ciz[i][j][0] - Ciz[i+1][j][0];
					ny[1] = Ciz[i][j][1] - Ciz[i+1][j][1];
					nz[1] = Ciz[i][j][2] - Ciz[i+1][j][2];
					x = ny[0]*nz[1] - ny[1]*nz[0];
					y = -nx[0]*nz[1] + nx[1]*nz[0];
					z = nx[0]*ny[1] - nx[1]*ny[0];
					tcol = z/sqrt(x*x + y*y + z*z);
					if(tcol > 0){
						Renk(COLOR(255,200*tcol,100*tcol));
						fillpoly(4, tmp);
					}
				}
				
		Renk(RENK_CIZ);
		if(cizik)
			for(i = 0; i<DETAY-1; i++){
				for(j = 0; j<DETAY-1; j++){
					dogru(Ciz[i][j][0], Ciz[i][j][1], Ciz[i][j+1][0], Ciz[i][j+1][1]);
					dogru(Ciz[i][j][0], Ciz[i][j][1], Ciz[i+1][j][0], Ciz[i+1][j][1]);
				}
				dogru(Ciz[DETAY-1][i][0], Ciz[DETAY-1][i][1], Ciz[DETAY-1][i+1][0], Ciz[DETAY-1][i+1][1]);
				dogru(Ciz[i][DETAY-1][0], Ciz[i][DETAY-1][1], Ciz[i+1][DETAY-1][0], Ciz[i+1][DETAY-1][1]);
			}

		setvisualpage(a%2);
	}
	return 1;
}
